/*
 * Name: kstat.h
 * Date: Mon Mar 06 22:42:37 2000
 * Author: pIGpEN [pigpen@s0ftpj.org, deadhead@sikurezza.org]
 *
 * SoftProject Digital Security for Y2K
 * Sikurezza.org - Italian Security Mailinglist
 *
 * COFFEE-WARE LICENSE - This source code is like "THE BEER-WARE LICENSE" by
 * Poul-Henning Kamp <phk@FreeBSD.ORG> but you can give me in return a coffee.
 *
 * Tested on: OpenBSD 2.6 kern#6 i386
 */

#include	<stdio.h>
#include	<unistd.h>
#include	<string.h>
#include	<err.h>
#include	<kvm.h>
#include	<fcntl.h>
#include	<nlist.h>

#define		Error(out)	err(1, "%s", out)
#define		Error_sym(out)	{ printf("Error generated by %s\n",out); \
				  exit(1); }
				  

/* Flags for nlist see kstat.h */

#define		IFNET_N		0	
#define		ALLPROC_N	1
#define		MOD_N		2

/* Flags for get_ifaddr() see util.c */

#define		GETADDR		0
#define	 	GETBCAST	1	
#define		GETDST		2
#define		GETNMASK	3

extern 		struct 	nlist list[];
struct		sockaddr;

/* see protosw.c */

#define		MAXPROTOSW	10

/*
 * Global Functions
 */


/* main.c */

int		main			__P((int, char**));


/* kvm.c */

int		check_val_kernel	__P((kvm_t *, int));

#define	FILE_SYM_TABLE	NULL

#define open_kernel(kd)  						     \
	if (!(kd=kvm_openfiles(NULL, FILE_SYM_TABLE, NULL, O_RDONLY, NULL))) \
		Error("[open_kernel] kvm_openfiles()"); 		     \
	if (kvm_nlist(kd, list) == -1) 					     \
		Error("[open_kernel] kvm_nlist()"); 

#define close_kernel(a) 	kvm_close(a)	


/* if.c */

int		if_info			__P((kvm_t *, char *));

/* util.c */

void		eth_addr		__P((char *));
void		p_addr			__P((struct sockaddr *, int));

void		get_ifaddr		__P((int, char *, int));

struct ifmediareq *
		get_ifmedia		__P((int, char *));

int		print_ifmedia		__P((struct ifmediareq *));

char *		addr_to_name		__P((int, u_long));
void		printb			__P((const char *, register unsigned,
					     register const char *));

/* ppp.c */

void		ppp_info		__P((char *));

/* proc.c */

void		bpf_to_proc		__P((kvm_t *, char *));

/* mod.c */

void		lookup_modules		__P((kvm_t *));

/* bpf.c */

void		check_bpf_cdevsw	__P((kvm_t *));

/* sysent.c */

void		check_sysent		__P((kvm_t *));	

/* protosw.c */

void		check_protosw		__P((kvm_t *));
