/*
 * Name: kvm library for kstat
 * Date: Mon Mar 06 21:58:37 2000
 * Author: pIGpEN [pigpen@s0ftpj.org, deadhead@sikurezza.org]
 *
 * SoftProject Digital Security for Y2K
 * Sikurezza.org - Italian Security Mailinglist
 *
 * COFFEE-WARE LICENSE - This source code is like "THE BEER-WARE LICENSE" by
 * Poul-Henning Kamp <phk@FreeBSD.ORG> but you can give me in return a coffee.
 *
 * Tested on: OpenBSD 2.6 kern#6 i386
 */


#include	"ksec.h"

#define		num_list(lst, tp)	(sizeof(lst) / sizeof(struct tp)) - 1

struct	nlist	list[] = {
	{	"_ifnet"	},
	{	"_allproc"	},
	{	"_linker_files"	},
	{	"_bpf_cdevsw"	},
	{	"_bpfopen"	},
	{	"_bpfclose"	},
	{	"_bpfread"	},
	{	"_bpfwrite"	},
	{	"_bpfioctl"	},
	{	"_bpfpoll"	},
	{	NULL		}
};


/*
 * Return 0 if ok, -1 if not..
 */

int 
check_val_kernel(kvm_t *kd, int position)
{
	register int flag = 0;
	
 	if (position >= num_list(list, nlist)) {
		printf("[check_val_kernel] checking position value\n");

		flag = 1;
	}

	if (!list[position].n_value) {
	 	printf("[check_val_kernel] has detected a n_value = 0 for %s\n",
					list[position].n_name); 

		flag = 1;
	}

	if (flag && kd) {
		printf("[check_val_kernel] Closing kd descriptor\n");
		kvm_close(kd);
	} 

	return ((flag) ? -1 : 0);
}
