/*
 * Name: PPP Support
 * Date: Mon Mar 27 21:21:40 2000
 * Author: pIGpEN [ pigpen@s0ftpj.org, deadhead@sikurezza.org ]
 *
 * SoftProject 2000 - Digital Sekurity for Y2k
 * Sikurezza.org - Italian Security MailingList
 *
 * COFFEE-WARE LICENSE - This source code is like "THE BEER-WARE LICENSE" by
 * Poul-Henning Kamp <phk@FreeBSD.ORG> but you can give me in return a coffee.
 *
 * Tested on: FreeBSD 3.4-RELEASE FreeBSD 3.4-RELEASE #4: Fri Mar i386
 */


#include "ksec.h"

#include <sys/param.h>
#include <sys/socket.h>
#include <sys/ioctl.h>
#ifdef	__OpenBSD__
#include <net/if.h>
#include <net/ppp_defs.h>
#endif
#include <net/if_ppp.h>

#define	p(x)	pppst.stats.x

/*
 * This part is not so critical... so we can do it via ioctl()
 */


void
ppp_info(char *ifp)
{
	struct ifpppstatsreq pppst;
	int s, mru=0;

	if ((s=socket(AF_INET, SOCK_DGRAM, 0)) < 0)
		Error("[ppp_info] socket()");

	
	if (ioctl(s, PPPIOCGMRU, &mru) != -1)
		printf("\tMRU = %d", mru);

	printf("PPP Statistics Information:\n");
	
	strncpy(pppst.ifr_name, ifp, IFNAMSIZ);
	pppst.ifr_name[sizeof(pppst.ifr_name) - 1] = '\0';
	
	if (ioctl(s, SIOCGPPPSTATS, &pppst) == -1) {
		printf("\t(none)\n");
		return ;
	}

	printf("\tbytes received  %d \tpackets received %d\n",
			p(p.ppp_ibytes),	p(p.ppp_ipackets));

	printf("\tbytes sent      %d \tpackets sent     %d\n",
			p(p.ppp_obytes),	p(p.ppp_opackets));

	printf("\terrors received %d \terrors transmit  %d\n",
			p(p.ppp_ierrors),	p(p.ppp_oerrors));

	printf("VJ Compression Statistics\n");

	printf("\toutbound:  pkts %d compressed %d searches %d missed %d\n",
			p(vj.vjs_packets),	p(vj.vjs_compressed), 
			p(vj.vjs_searches),	p(vj.vjs_misses));

	printf("\t inbound:  compressed %d uncompressed %d errors %d tossed %d\n",
			p(vj.vjs_compressedin),	p(vj.vjs_uncompressedin),
			p(vj.vjs_errorin),	p(vj.vjs_tossed));

	close(s);
}	
